// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marine_sensor_msgs:msg/RadarEcho.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marine_sensor_msgs/msg/radar_echo.h"


#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_H_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'echoes'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/RadarEcho in the package marine_sensor_msgs.
/**
  * This message is a submessage of RadarSector and is not intended
  * to be used separately. It represents intensities from a
  * single ray.
 */
typedef struct marine_sensor_msgs__msg__RadarEcho
{
  /// Series of intensities from closest to farthest
  /// along a given angle increment.
  rosidl_runtime_c__float__Sequence echoes;
} marine_sensor_msgs__msg__RadarEcho;

// Struct for a sequence of marine_sensor_msgs__msg__RadarEcho.
typedef struct marine_sensor_msgs__msg__RadarEcho__Sequence
{
  marine_sensor_msgs__msg__RadarEcho * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marine_sensor_msgs__msg__RadarEcho__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_ECHO__STRUCT_H_
