// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marine_sensor_msgs/msg/radar_sector.hpp"


#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__STRUCT_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <cstdint>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'time_increment'
// Member 'scan_time'
#include "builtin_interfaces/msg/detail/duration__struct.hpp"
// Member 'intensities'
#include "marine_sensor_msgs/msg/detail/radar_echo__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marine_sensor_msgs__msg__RadarSector __attribute__((deprecated))
#else
# define DEPRECATED__marine_sensor_msgs__msg__RadarSector __declspec(deprecated)
#endif

namespace marine_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarSector_
{
  using Type = RadarSector_<ContainerAllocator>;

  explicit RadarSector_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    time_increment(_init),
    scan_time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->angle_start = 0.0f;
      this->angle_increment = 0.0f;
      this->range_min = 0.0f;
      this->range_max = 0.0f;
    }
  }

  explicit RadarSector_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    time_increment(_alloc, _init),
    scan_time(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->angle_start = 0.0f;
      this->angle_increment = 0.0f;
      this->range_min = 0.0f;
      this->range_max = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _angle_start_type =
    float;
  _angle_start_type angle_start;
  using _angle_increment_type =
    float;
  _angle_increment_type angle_increment;
  using _time_increment_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _time_increment_type time_increment;
  using _scan_time_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _scan_time_type scan_time;
  using _range_min_type =
    float;
  _range_min_type range_min;
  using _range_max_type =
    float;
  _range_max_type range_max;
  using _intensities_type =
    std::vector<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>>;
  _intensities_type intensities;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__angle_start(
    const float & _arg)
  {
    this->angle_start = _arg;
    return *this;
  }
  Type & set__angle_increment(
    const float & _arg)
  {
    this->angle_increment = _arg;
    return *this;
  }
  Type & set__time_increment(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->time_increment = _arg;
    return *this;
  }
  Type & set__scan_time(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->scan_time = _arg;
    return *this;
  }
  Type & set__range_min(
    const float & _arg)
  {
    this->range_min = _arg;
    return *this;
  }
  Type & set__range_max(
    const float & _arg)
  {
    this->range_max = _arg;
    return *this;
  }
  Type & set__intensities(
    const std::vector<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<marine_sensor_msgs::msg::RadarEcho_<ContainerAllocator>>> & _arg)
  {
    this->intensities = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> *;
  using ConstRawPtr =
    const marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marine_sensor_msgs__msg__RadarSector
    std::shared_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marine_sensor_msgs__msg__RadarSector
    std::shared_ptr<marine_sensor_msgs::msg::RadarSector_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarSector_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->angle_start != other.angle_start) {
      return false;
    }
    if (this->angle_increment != other.angle_increment) {
      return false;
    }
    if (this->time_increment != other.time_increment) {
      return false;
    }
    if (this->scan_time != other.scan_time) {
      return false;
    }
    if (this->range_min != other.range_min) {
      return false;
    }
    if (this->range_max != other.range_max) {
      return false;
    }
    if (this->intensities != other.intensities) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarSector_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarSector_

// alias to use template instance with default allocator
using RadarSector =
  marine_sensor_msgs::msg::RadarSector_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marine_sensor_msgs

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__STRUCT_HPP_
